(require 'pd-package)
(use-package :predicate-dispatch)

(defpdmethod linearize ((expr ge-times) &aux (terms (terms-of expr)) mi)
  ((setf mi (match-or-nil terms '(* sin? * sin? *))))
  (let ((x (arg-of (second mi))) (y (arg-of (fourth mi))))
    (make-ge-times (domain-of expr)
		   (append (list 1/2 (- (cos (- x y)) (cos (+ x y))))
			   (first mi) (third mi) (fifth mi)))))
