(require 'predicate-dispatch)
(use-package 'predicate-dispatch)

;(defgeneric hailstone (n)
;  (:generic-function-class gf-with-predicate-dispatching))

(defpdmethod hailstone (n)
  ((evenp n))
  (/ n 2))

(defpdmethod hailstone (n)
  ((oddp n))
  (+ (* n 3) 1))

(defun hsseq (n)
  (if (= n 1)
      '(1)
    (cons n (hsseq (hailstone n)))))
