(require 'predicate-dispatch)
(use-package 'predicate-dispatch)
(require 'pc-print)

;#+CMU
;(setf *describe-print-level* 4
;      *describe-print-length* nil
;      *describe-level* 5)

#+CMU
(defun lisp::output-interpreted-function (subr stream)
  (multiple-value-bind
      (def ignore name)
      (eval:interpreted-function-lambda-expression subr)
    (declare (ignore ignore))
    (let ((*print-level* 5))
      (format stream "Interpreted Function ~S" (or name def)))))

; (defgeneric *test* (foo bar)
;   (:generic-function-class gf-with-predicate-dispatching))

(defpdmethod *test* ((foo standard-object) (bar standard-class))
  ((eql (class-of foo) bar))
  t)

(describe '*test*)
(terpri)
(quit)
